/*
 * @(#)ManyToMany.java	2011-9-5
 *
 * Copyright (c) 2011. All Rights Reserved.
 *
 */

package org.javaclub.jorm.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * ManyToMany
 *
 * @author <a href="mailto:gerald.chen.hz@gmail.com">Gerald Chen</a>
 * @version $Id: ManyToMany.java 520 2011-10-03 12:29:49Z gerald.chen.hz@gmail.com $
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
public @interface ManyToMany {
	
	/**
	 * if support cascade operation, default is true.
	 *
	 * @return <code>true</code> if is cascade operation, otherwise <code>false</code>
	 */
	boolean cascade() default true;
	
	String table() default "";
	
	String mappedId();
	
	Class<?> type();
}
