/*
 * @(#)ManyToOne.java	2011-9-5
 *
 * Copyright (c) 2011. All Rights Reserved.
 *
 */

package org.javaclub.jorm.annotation;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

/**
 * ManyToOne
 *
 * @author <a href="mailto:gerald.chen.hz@gmail.com">Gerald Chen</a>
 * @version $Id: ManyToOne.java 409 2011-09-20 08:37:59Z gerald.chen.hz $
 */
@Retention(RetentionPolicy.RUNTIME)
@Target(ElementType.FIELD)
public @interface ManyToOne {
	
	

	/**
	 * "One" item's primary key field names.
	 *
	 * @return
	 */
	String[] selField() default {};
	
	/**
	 * "Many" item's foreign key field names.
	 *
	 * @return
	 */
	String[] ownerField() default {};
}
